package com.sample;

import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


import org.drools.KnowledgeBase;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.compiler.PackageBuilderConfiguration;
import org.drools.io.ResourceFactory;
import org.drools.logger.KnowledgeRuntimeLogger;
import org.drools.logger.KnowledgeRuntimeLoggerFactory;
import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.process.ProcessInstance;
import org.jbpm.process.workitem.wsht.CommandBasedWSHumanTaskHandler;



public class MibBpmServiceProvider {
	
public static void main(String[] args) {
	startNotificationProcess();
	}
	public static void startNotificationProcess() {
		Map<String, Object> params = new HashMap<String, Object>();
//		CollectionDaoIntf dao=new CollectionDaoImpl();
		try {
//			MIBMailSender.REQUEST = request;
//			String roleType=(String)request.getSession().getAttribute("ROLE_TYPE");
//			System.out.println("role type in MibBpm"+roleType);
			/*KnowledgeBase kbase = readNotificationKnowledgeBase();
			StatefulKnowledgeSession ksession = kbase.newStatefulKnowledgeSession();
			ksession.startProcess("notification.service");
			ksession.insert(request);*/
			
			//JBPM Change
			KnowledgeBase kbase = readKnowledgeBase();
			StatefulKnowledgeSession ksession = kbase.newStatefulKnowledgeSession();
			ksession.getWorkItemManager().registerWorkItemHandler("Human Task", new CommandBasedWSHumanTaskHandler(ksession));
			// start a new process instance
			
//			String requestId = common.getTimeStampFromFileName(filename);
			/*params.put("request", request);
			params.put("response", response);
			params.put("form", form);
			params.put("mapping", mapping);*/
//			params.put("fileName", filename);
			params.put("requestId", "123456789");
			params.put("finApprover", "Deep");
		    params.put("manager", "Manager");
			/*if(requestId !=null  && requestId.length>0){
				params.put("requestId", requestId[0]);
				params.put("finApprover", MIBConstants.FIN_ROLE+"-"+requestId[0]);
				params.put("manager", MIBConstants.MGR_ROLE+"-"+requestId[0]);
			}*/
			ProcessInstance processInstance = ksession.startProcess("com.sample.bpmn.hello", params);
			System.out.println("Process started ...");
			System.out.println(processInstance.getId());
			//JBPM Change
			
		} catch (Throwable t) {
			t.printStackTrace();
		}
	}
	
	private static KnowledgeBase readKnowledgeBase() throws Exception {
		
		Properties properties = new Properties();
		properties.setProperty( "drools.dialect.java.compiler.lnglevel","1.6" );
		PackageBuilderConfiguration cfg = new PackageBuilderConfiguration( properties );
		KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder(cfg);
		
		kbuilder.add(ResourceFactory.newClassPathResource("Notification.bpmn"), ResourceType.BPMN2);
		return kbuilder.newKnowledgeBase();
	}

	
}